/*
 * $Header:$
 * $Source:$
 */

#include "defs.c"

list freelist;
int tnow=0;
#define ABSTIM(w) (tnow+w)
list new_cell()
{
  register list nlist;
  if(freelist!=nil) 
    {
      nlist=freelist; freelist=freelist->next; nlist->next=nil;
      return(nlist);
    }
  else				/* error("Out of cells"); */
    {
      makecells();
      return(new_cell());
    }
}

makecells()
{
  list strt,tfr; int i;
  list sbrk();

  tfr=strt=sbrk(1024*sizeof(cell));

  for(i=0;i<1024-1;i++)		/* stop with one left for back link */
    {
      strt->val.num=0;
      strt->next=(strt+1);
      strt++;
    }
  strt->val.num=0;

  strt->next=freelist;
  freelist=tfr;
#ifdef DEBUG
  printf("Grabbed 1024 more cells\n");
#endif DEBUG
}

freecells(dead)
     list dead;
{
  register list tmp=dead;
  
  ELIST(tmp);			/*   WLIST(tmp->next) tmp=tmp->next; */
  tmp->next=freelist;
  freelist=dead;
}

list ncell(elem,nxt)
     value elem; list nxt;
{
  register list ltmp;
  ltmp=new_cell(); ltmp->val=elem; ltmp->next=nxt;
  return(ltmp);
}

setval(conn,what,when)
     list conn;
     int what;			/* new level */
     int when;			/* when to do it (propagation delay) */
{
  register list wt;
  register list wt2;

#ifdef DEBUG
  printf("setval %x, %d@%d\n",conn,what,when);
#endif DEBUG
  wt=conn->val.list;

  WLIST(wt->next)
    {

      if(wt->next->val.num > ABSTIM(when)) break;
      wt=wt->next->next;
    }

  wt2=ncell(what,wt->next);
  wt->next=ncell(ABSTIM(when),wt2);
}

tackval(lval,what,when)
     list lval;
     int what;			/* new level */
     int when;			/* when to do it (propagation delay) */
{
  register list wt=lval;
  register list wt2;

#ifdef DEBUG
  printf("initval %x, %d@%d\n",conn,what,when);
#endif DEBUG
  wt2=ncell(what,wt->next);
  wt->next=ncell(ABSTIM(when),wt2);
}

changed_connection(cnn)
     list cnn;
{
  register list node;
  register list conn=cnn;

  conn=conn->next; if(conn==nil) return; /* nothing hooked to this one */

  SCANL(conn)
    {
      /* handle this node */
      node=conn->val.list;
      node->val.proc(node->next);
    }
}

int search_all(cnnlist)
     list cnnlist;
{
  register list N_TICK_OPT;
  register list connlist=cnnlist;
  register int tcur, tmin;

  if(connlist==nil) error("Null circuit");
  tmin=nexttick(connlist);
  connlist=connlist->next;
#ifdef DEBUG
  printf("tmin initial=%d\n",tmin);
#endif DEBUG

  SCANL(connlist)
    {
      tcur=nexttick(connlist);
#ifdef DEBUG
      printf("tcur=%d\n",tmin);
#endif DEBUG
      if(tcur!=-1)
	{
	  if(tmin==-1) tmin=tcur;
	  else if(tmin>tcur) tmin=tcur;
	  /* tmin=min(tcur,tmin); */
	}
    }
#ifdef DEBUG
  printf("tmin final=%d\n",tmin);
#endif DEBUG
  return(tmin);
}
	
scan_all(cnnlist,tmin)
     list cnnlist;
     int tmin;
{
  register list N_TICK_OPT;
  register int tcur;
  register list conn, dump;
  register list connlist=cnnlist;

  SCANL(connlist)
    {
      conn=connlist->val.list;
      if(connwire(conn)->next==nil) continue; /* no pending changes */
      tcur=conntick(conn);
#ifdef DEBUG
      printf("scanning conn %x @%d\n",conn,tcur);
#endif DEBUG
      if(tcur==tmin)
	{
	  dump=connwire(conn);
	  connwire(conn)=connwire(conn)->next->next;
	  dump->next->next=nil;
	  if(dump->val.num!=connwire(conn)->val.num) changed_connection(conn);
	  freecells(dump);
	}
      else if(tcur<tmin) error("time phase error in scan_all");
    }
}

run(connlist)
     list connlist;
{
  int metastable=0;
  while(metastable<METAWARN)
    {
      tnow=search_all(connlist);
#ifdef DEBUG
      printf("tnow=%d\n",tnow);
#endif DEBUG
      if (tnow==0) metastable++;
      else metastable=0;
      if (tnow==-1) 
	{
	  printf("All done.\n");
	  return;
	}
      scan_all(connlist,tnow);
    }
  printf("Exceeded METAWARN %d instant states\n",metastable);
  return;
}

list newconn(init_value)
     list init_value;
{
  /* no circuits, just one value, none pending */
  return(ncell(ncell(init_value,nil),nil));
}
