/*
 * tristate.c
 * a few pieces for a running simulator.
 * [eichin:19880401.0606EST]
 */

#include <msimdecl.h>

/*
 * z = tristate(a, b): if (a==HI) then b else TRISTATE
 */ 
tristate_func(dep)
     Generics dep;
{
  Event futev = getblock();
  Wire outwire;
  Timeline outtime;
  
  START(futev);

  nextwire(dep, outwire, outtime);
  {
    Wire awire;
    Timeline aline;

    readnextwire(dep, awire, aline);    

      
    if(aline->tag.EVENT == LOGIC_HI)
      {
	ASSERT(dep->tag.GENERIC == GENWIRE);
	awire = dep->data.GENERIC.genwire;
	find_item(awire, WIRE, NOW);
	
	set_event(futev, awire[0].data.WIRE.now[0].tag.EVENT, globaltime + 10);
      }
    else
      {
	set_event(futev, TRISTATE, globaltime + 10);
      }
  }
  
  add_event(outtime, futev->tag.EVENT, futev->data.EVENT);
  back_trace(futev);
}
