#define EXPAND(refptr)\
{\
  ASSERT(refptr->tag.CTL == END);\
  if (refptr->data.CTL == end)\
    {\
      ropeptr tmpptr;\
      \
      refptr->tag.CTL = NEXT_FORWARD;\
\
      tmpptr = getblock();\
      ASSERT(refptr->tag.CTL == NEXT_BACKWARD);\
      tmpptr->data.NEXT = refptr-1;\
\
      refptr = refptr->data.NEXT = tmpptr+1;\
    }\
}\

#define INC(refptr)\
{\
  if(((++refptr)->tag.CTL == NEXT_FORWARD)\
     || (refptr->tag.CTL == NEXT_FORWARD_UNALIGNED))\
    {\
      refptr = refptr->data.NEXT;\
    }\
}\

#define START(refptr) INC(refptr)\

#define DEC(refptr)\
{\
  if(((--refptr)->tag.CTL == NEXT_BACKWARD)\
     || (refptr->tag.CTL == NEXT_BACKWARD_UNALIGNED))\
    {\
      refptr = refptr->data.NEXT;\
    }\
}\

#define insert_cell(refptr)\
{\
  rope_elem cpy, cpy2;\
  cpy.tag.CTL = END;\
  cpy.data.CTL = end;\
\
  while(refptr->tag.CTL != END)\
    {\
      cpy2 = *refptr;\
      *refptr = cpy;\
      cpy = cpy2;\
      INC(refptr);\
    }\
  EXPAND(refptr);\
  *refptr = cpy;\
}\

#define compress(refptr)\
{\
  ASSERT(refptr->tag.CTL == END);\
  refptr--;\
  if (refptr->tag.CTL == NEXT_BACKWARD)\
    {\
      ropeptr savptr;\
      savptr = refptr->data.NEXT;\
      make_free(refptr);\
      refptr = savptr++;	/* savptr is the tail of the BACK block */\
      savptr->tag.CTL = END;\
      savptr->data.CTL = end;\
    }\
  if (refptr->tag.CTL == NEXT_BACKWARD_UNALIGNED)\
    {\
      ropeptr savptr;\
      savptr = refptr->data.NEXT;\
      refptr->tag.CTL = END;\
      refptr->data.CTL = end;\
      refptr = savptr++;	/* savptr is NOT the tail...*/\
      savptr->tag.CTL = END;\
      savptr->data.CTL = notend;\
    }\
}\

#define useup(refptr, ENDHANDLER)\
{\
  refptr->tag.CTL = END;\
  refptr->data.CTL = notend;\
  refptr++;\
  if (refptr->tag.CTL == END)\
    {\
      make_free(refptr);\
      ENDHANDLER;		/* usually break or continue... */\
    }\
  if (refptr->tag.CTL == NEXT_FORWARD)\
    {\
      ropeptr nxtptr;\
      nxtptr = refptr->data.NEXT;\
      /*       s2ptr = refptr;??? */\
      refptr->tag.CTL = END;\
      refptr->data.CTL = end;\
      while(refptr->tag.CTL != BEGIN)\
	{\
	  refptr --;\
	}\
      (--nxtptr)->tag.CTL = BEGIN;\
      nxtptr->data.NEXT = refptr->data.NEXT;\
      make_free(refptr);\
\
      refptr = nxtptr+1;\
    }\
}\

#define back_trace(refptr)\
{\
  while(refptr->tag.CTL != BEGIN)\
    {\
      refptr --;\
    }\
  make_free(refptr);\
}\

#define make_free(refptr)\
{\
  refptr->tag.CTL = FREELIST;\
  refptr->data.NEXT = nextfree;\
  nextfree = refptr;\
}\

#define set_item(wire, TYPE, piece, partname, value)\
{\
  EXPAND(wire);\
  wire->tag.TYPE = piece;\
  (wire->data.TYPE.partname) = value;\
}\

#define set_event(evptr, value, time)\
{\
  EXPAND(evptr);\
  evptr->tag.EVENT = value;\
  evptr->data.EVENT = time;\
}\

#define add_item(wire, TYPE, piece, partname, value)\
{\
  set_item(wire->data.NEXT, TYPE, piece, partname, value);\
  INC(wire->data.NEXT);\
}\

#define add_event(timlin, value, time)\
{\
  set_event(timlin->data.NEXT, value, time);\
  INC(timlin->data.NEXT);\
}\

#define add_chain(wire, TYPE, piece, partname)\
{\
  add_item(wire, TYPE, piece, partname, getblock());\
}\

#define find_item(wire, TYPE, value)\
{\
  while(wire->tag.TYPE != END)\
    {\
      if(wire->tag.TYPE == value) break;\
      INC(wire);\
    }\
}\

#define nextwire(argv, wire, time)\
{\
  wire = argv->data.GENERIC.genwire;\
  ASSERT(argv->tag.GENERIC == genwire);\
  find_item(wire, WIRE, FUTURE);\
  time = wire->data.WIRE.future;\
  INC(argv);\
}\

#define readnextwire(argv, wire, time)\
{\
  wire = argv->data.GENERIC.genwire;\
  ASSERT(argv->tag.GENERIC == genwire);\
  find_item(wire, WIRE, NOW);\
  time = wire->data.WIRE.now;\
  INC(argv);\
}\

#ifdef __STDC__
#define MAKEWIRE(NAME)\
Wire NAME = new_to_wirelist(master, #NAME)\

#else
#define MAKEWIRE(NAME)\
Wire NAME = new_to_wirelist(master, "NAME")\

#endif
#define chain_init(newdep, func)\
{\
  newdep = getblock();\
  add_item(newdep, GENERIC, GENFUNC, genfunc, func);\
}\

#define chain_add(newdep, wire)\
{\
  add_item(newdep, GENERIC, GENWIRE, genwire, wire);\
}\

#define chain_dep(wire, newdep)\
{\
  Wire tmpwire = wire;\
  find_item(tmpwire, WIRE, DEPENDS);\
  add_item(tmpwire->data.DEPS.generics, DEPS, DEPSLIST, generics, newdep);\
}\

#define make_arg1(op)\
{\
  Generics wlist;\
  chain_init(wlist, op);\

#define make_dep0(a1)\
}\

#define make_arg2(op, a1)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\

#define make_dep1(a1)\
  chain_dep(a1, wlist);\
}\

#define make_arg3(op, a1, a2)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\
  chain_add(wlist, a2);\

#define make_dep2(a1, a2)\
  chain_dep(a1, wlist);\
  chain_dep(a2, wlist);\
}\

#define make_arg4(op, a1, a2, a3)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\
  chain_add(wlist, a2);\
  chain_add(wlist, a3);\

#define make_dep3(a1, a2, a3)\
  chain_dep(a1, wlist);\
  chain_dep(a2, wlist);\
  chain_dep(a3, wlist);\
}\

#define make_arg5(op, a1, a2, a3, a4)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\
  chain_add(wlist, a2);\
  chain_add(wlist, a3);\
  chain_add(wlist, a4);\

#define make_dep4(a1, a2, a3, a4)\
  chain_dep(a1, wlist);\
  chain_dep(a2, wlist);\
  chain_dep(a3, wlist);\
  chain_dep(a4, wlist);\
}\

#define make_arg6(op, a1, a2, a3, a4, a5)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\
  chain_add(wlist, a2);\
  chain_add(wlist, a3);\
  chain_add(wlist, a4);\
  chain_add(wlist, a5);\

#define make_dep5(a1, a2, a3, a4, a5)\
  chain_dep(a1, wlist);\
  chain_dep(a2, wlist);\
  chain_dep(a3, wlist);\
  chain_dep(a4, wlist);\
  chain_dep(a5, wlist);\
}\

#define make_arg7(op, a1, a2, a3, a4, a5, a6)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\
  chain_add(wlist, a2);\
  chain_add(wlist, a3);\
  chain_add(wlist, a4);\
  chain_add(wlist, a5);\
  chain_add(wlist, a6);\

#define make_dep6(a1, a2, a3, a4, a5, a6)\
  chain_dep(a1, wlist);\
  chain_dep(a2, wlist);\
  chain_dep(a3, wlist);\
  chain_dep(a4, wlist);\
  chain_dep(a5, wlist);\
  chain_dep(a6, wlist);\
}\

#define make_arg8(op, a1, a2, a3, a4, a5, a6, a7)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\
  chain_add(wlist, a2);\
  chain_add(wlist, a3);\
  chain_add(wlist, a4);\
  chain_add(wlist, a5);\
  chain_add(wlist, a6);\
  chain_add(wlist, a7);\

#define make_dep7(a1, a2, a3, a4, a5, a6, a7)\
  chain_dep(a1, wlist);\
  chain_dep(a2, wlist);\
  chain_dep(a3, wlist);\
  chain_dep(a4, wlist);\
  chain_dep(a5, wlist);\
  chain_dep(a6, wlist);\
  chain_dep(a7, wlist);\
}\

#define make_arg9(op, a1, a2, a3, a4, a5, a6, a7, a8)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\
  chain_add(wlist, a2);\
  chain_add(wlist, a3);\
  chain_add(wlist, a4);\
  chain_add(wlist, a5);\
  chain_add(wlist, a6);\
  chain_add(wlist, a7);\
  chain_add(wlist, a8);\

#define make_dep8(a1, a2, a3, a4, a5, a6, a7, a8)\
  chain_dep(a1, wlist);\
  chain_dep(a2, wlist);\
  chain_dep(a3, wlist);\
  chain_dep(a4, wlist);\
  chain_dep(a5, wlist);\
  chain_dep(a6, wlist);\
  chain_dep(a7, wlist);\
  chain_dep(a8, wlist);\
}\

#define make_arg10(op, a1, a2, a3, a4, a5, a6, a7, a8, a9)\
{\
  Generics wlist;\
  chain_init(wlist, op);\
  chain_add(wlist, a1);\
  chain_add(wlist, a2);\
  chain_add(wlist, a3);\
  chain_add(wlist, a4);\
  chain_add(wlist, a5);\
  chain_add(wlist, a6);\
  chain_add(wlist, a7);\
  chain_add(wlist, a8);\
  chain_add(wlist, a9);\

#define make_dep9(a1, a2, a3, a4, a5, a6, a7, a8, a9)\
  chain_dep(a1, wlist);\
  chain_dep(a2, wlist);\
  chain_dep(a3, wlist);\
  chain_dep(a4, wlist);\
  chain_dep(a5, wlist);\
  chain_dep(a6, wlist);\
  chain_dep(a7, wlist);\
  chain_dep(a8, wlist);\
  chain_dep(a9, wlist);\
}\

#ifdef __STDC__
#define make_anop(opc, argops, argc, args)\
make_arg##argc args make_dep##opc argops\

#else
#define make_anop(opc, argops, argc, args)\
make_arg/**/argc args make_dep/**/opc argops\

#endif
#define make_binop(op, c, a, b) make_anop(2,(a, b),4,(op, c, a, b))\

#define make_unop(op, b, a) make_anop(1,(a),3,(op, b, a))\

#define make_tracer(op, line) make_anop(1,(line),2,(op,line))\

#define SETWIRE(wire, level, time)\
{\
  Timeline t1;\
  Wire ww = wire;\
  find_item(ww, WIRE, FUTURE);\
  t1 = ww->data.WIRE.future;\
  add_event(t1, level, time);\
}\

#define FileArgs(master,argc,argv)\
int dummy2 = initialize_file(master, argc, argv)\

#define MOREARGS(dep)\
dep->tag.CTL != END\

#define SAVEOUTWIRE(argv, wire)\
{\
  wire = argv->data.GENERIC.genwire;\
  ASSERT(argv->tag.GENERIC == genwire);\
  INC(argv);\
}\

#define READNEXTSTATE(argv, event)\
{\
  Wire wire = argv->data.GENERIC.genwire;\
  ASSERT(argv->tag.GENERIC == genwire);\
  find_item(wire, WIRE, NOW);\
  event = wire->data.WIRE.now->tag.EVENT;\
  INC(argv);\
}\

#define READNEXTSTATETIME(argv, event, time)\
{\
  Wire wire = argv->data.GENERIC.genwire;\
  ASSERT(argv->tag.GENERIC == genwire);\
  find_item(wire, WIRE, NOW);\
  event = wire->data.WIRE.now->tag.EVENT;\
  time = wire->data.WIRE.now->data.EVENT;\
  INC(argv);\
}\

#define READNEXTTIME(argv, tim)\
{\
  tim = argv->data.GENERIC.gentime;\
  ASSERT(argv->tag.GENERIC == GENTIME);\
  INC(argv);\
}\

#define SETOUTPUT(wire, val, time)\
{\
  Wire tmpwire = wire;\
  find_item(wire, WIRE, FUTURE);\
  add_event(wire->data.WIRE.future, val, time);\
}\

#define STATE Event_tag
