/*
 * or.c
 * a few pieces for a running simulator.
 * [eichin:19880401.0606EST]
 */

#include <msimdecl.h>

/*
 * z = or(a, b...): if (a==LOW) then and(b...) else HI
 */ 
or_func(dep)
     Generics dep;
{
  Event futev = getblock();
  Wire outwire;
  Timeline outtime;
  
  START(futev);
  set_event(futev, LOGIC_LOW, globaltime + 10);

  nextwire(dep, outwire, outtime);
  
  while(dep->tag.CTL != END)
    {
      Wire awire;
      Timeline aline;

      readnextwire(dep, awire, aline);
      
      if(aline->tag.EVENT == LOGIC_LOW)
	{
	  continue;
	}
      else
	{
	  set_event(futev, LOGIC_HI, globaltime + 10);
	  break;
	}
    }
  
  add_event(outtime, futev->tag.EVENT, futev->data.EVENT);
  back_trace(futev);
}
